# SFM2 Python library v0.7

This is a python library for SFM2 devices. Currently, it only supports USB connection.

## Setup

- The library runs on Python 3.7 or newer.

- Make sure *distutils* and *python3-pip* packages are available:
    - ```sudo apt-get install python3-distutils```
    - ```sudo apt-get install python3-pip```

- With the utils installed you can install dependencies from requirements.txt:
    - ```pip3 install -r requirements.txt```

## Running samples

Python (*.py) files in the *samples* directory (e.g. *samples/running_self_test.py*) show how to use the library.

Start with *samples/reading_sensor_fusion_data.py* as it's the simplest one.

To run one of the samples navigate to *samples* directory and run e.g. ```python3 reading_sensor_fusion_data.py```

## Using the library in your own project

To use the library in your own project simply copy the *sfm2* directory to the root of your project and import it by the name *sfm2*

Your project structure can look like this:
```
your project root
│  
└───main.py
│     Your code goes here
│  
└───sfm2
      The sfm2 lib. Simply copy it from here.
```

Then you can copy the following code into *main.py* 

```
import logging

from sfm2.sfm2_factory import Sfm2Factory

logging.basicConfig(level=logging.INFO)

sfm2 = Sfm2Factory.connect_first_found()
sfm2.reset()
sfm2.sensor_fusion.rate = 13
sfm2.sensor_fusion.quaternion.subscribe(print)

input("Click enter twice to exit\n")
```

And start from there...
