import logging

from _add_lib_to_path import add_lib_to_path

# This function adds the project root to PATH
add_lib_to_path()

from sfm2.interface.sfm2_init_options import Sfm2InitOptions
from sfm2.sfm2_factory import Sfm2Factory

_FILENAME = "logs.txt"
logging.basicConfig(
    level=logging.DEBUG,
    filename=_FILENAME,
    format='%(asctime)s - %(name)s - %(levelname)s - %(message)s',
    datefmt='%Y-%m-%d %H:%M:%S')

print(f"Logs will be written to {_FILENAME}")

logging.info("Starting up")

sfm2 = Sfm2Factory.connect_first_found(Sfm2InitOptions(log_all_cmds=True))

sfm2.reset()
sfm2.config.asr = 13
sfm2.data.ad.subscribe(print)

input("Click enter twice to exit\n")
