import logging

from _add_lib_to_path import add_lib_to_path

# This function adds the project root to PATH
add_lib_to_path()

from sfm2.interface.env_sensor_config_types import PressureSampleRate, TemperatureSamplingSetup
from sfm2.sfm2_factory import Sfm2Factory

logging.basicConfig(level=logging.INFO)

sfm2 = Sfm2Factory.connect_first_found()

sfm2.reset()

# You can use either "env_sensors"...
sfm2.env_sensors.pressure.subscribe(print)

# ...or just "env"
sfm2.env.altitude.subscribe(print)

sfm2.env.temperature.subscribe(print)
sfm2.env.humidity.subscribe(print)

sfm2.env.pressure_altitude_sample_rate = PressureSampleRate.HZ_1
sfm2.env.temperature_humidity_sampling_setup = TemperatureSamplingSetup.interval_s(1)

input("Click enter twice to tare altitude\n")

sfm2.env_sensors.tare_altitude()

input("Click enter twice to exit\n")
