import logging

from _add_lib_to_path import add_lib_to_path

# This function adds the project root to PATH
add_lib_to_path()

from sfm2.interface.sfm2_config import SampleRate
from sfm2.sfm2_factory import Sfm2Factory
from sfm2.utils.throughput import calculate_throughput

logging.basicConfig(level=logging.INFO)

sfm2 = Sfm2Factory.connect_first_found()
sfm2.reset()

ad = sfm2.data.ad
gd = sfm2.data.gd
# If you need to calculate throughput of a single stream then you can just call:
# d = calculate_throughput(ad).subscribe(lambda r: print(f"AD: {r}"))
d = calculate_throughput((ad, gd)).subscribe(lambda r: print(f"AD: {r[0]} GD: {r[1]}"))

for sr in SampleRate:
    if sr == SampleRate.OFF:
        continue
    print(f"Setting sample rate to {sr.value}Hz")
    sfm2.config.asr = sr
    sfm2.config.gsr = sr

    if sr == SampleRate.MAX:
        input("Click enter twice to exit\n")
    else:
        input("Click enter twice to increase sample rate\n")

d.dispose()
sfm2.reset()
