import logging

from _add_lib_to_path import add_lib_to_path

# This function adds the project root to PATH
add_lib_to_path()

from sfm2.sfm2_factory import Sfm2Factory

logging.basicConfig(level=logging.WARNING)

sfm2 = Sfm2Factory.connect_first_found()
sfm2.reset()

sfm2.sensor_fusion.rate = 13

sf = sfm2.sensor_fusion.euler_angles.subscribe(print)

input("All set up. Click enter twice to tare\n")

sfm2.reference.tare_now()

input("Tared. Click enter twice to start GLOBREF test\n")

# Stop printing Sensor Fusion data
sf.dispose()

sfm2.acc.data.subscribe(print)

print("Acceleration output enabled. Rotate the device and see how the reading changes.")
input("Click enter twice to enable GLOBREF\n")

sfm2.reference.globref = True

print(
    "Acceleration vector is now given in global reference frame."
    " The reading shouldn't change much when you rotate the device. Give it a try")

input("Click enter twice to exit\n")

sfm2.reset()
