import logging
from datetime import timedelta
from time import sleep

from _add_lib_to_path import add_lib_to_path

# This function adds the project root to PATH
add_lib_to_path()

from sfm2.sfm2_factory import Sfm2Factory

# Consider using TimeSync utility instead of direct time manipulation.
# See "synchronizing_time.py" for sample usage.

logging.basicConfig(level=logging.WARNING)

sfm2 = Sfm2Factory.connect_first_found()

t1 = sfm2.time.get()
print(f"T1: {t1}")

print("Setting time to 10s")
sfm2.time.set(timedelta(seconds=10))
t2 = sfm2.time.get()
print(f"T2: {t2}")

time_to_sleep_s = 2
print(f"Waiting for {time_to_sleep_s}s")
sleep(time_to_sleep_s)
t3 = sfm2.time.get()
print(f"T3: {t3}. (T3 - T2): {t3 - t2}")

print("Applying 1-minute offset")
sfm2.time.apply_offset(timedelta(minutes=1))
t4 = sfm2.time.get()
print(f"T4: {t4}. (T4 - T3): {t4 - t3}")

print("Resetting time")
sfm2.time.reset()
t5 = sfm2.time.get()
print(f"T5: {t5}")
