from dataclasses import dataclass

from sfm2.interface.exceptions import MalformedDataException


@dataclass(frozen=True)
class Command:
    name: str

    @property
    def query_str(self) -> str:
        return f"{self.name}?"

    @property
    def command_str(self) -> str:
        return f"{self.name}!"

    def set_value_str(self, value: str) -> str:
        return f"{self.name}={value}"

    def strip_value(self, response: str) -> str:
        prefix = f"{self.name}="
        if not response.startswith(prefix):
            MalformedDataException(f"String {response} is not a vaild response to {self}") \
                .raise_and_log_error()
        chars_to_skip = len(prefix)
        return response[chars_to_skip:]
