from typing import Union

from rx.core.typing import Observable

from sfm2.interface.sample_types import VectorSample
from sfm2.interface.sfm2_accelerometer import Sfm2Accelerometer
from sfm2.interface.sfm2_config import SampleRate, AccelFullRange, Sfm2Config
from sfm2.interface.sfm2_data import Sfm2Data


class Sfm2AccelerometerImpl(Sfm2Accelerometer):
    def __init__(self, config: Sfm2Config, data: Sfm2Data):
        self._config = config
        self._data = data

    @property
    def data(self) -> Observable[VectorSample]:
        return self._data.ad

    @property
    def rate(self) -> SampleRate:
        return self._config.asr

    @rate.setter
    def rate(self, rate: Union[SampleRate, float]) -> None:
        self._config.asr = rate

    @property
    def range(self) -> AccelFullRange:
        return self._config.afr

    @range.setter
    def range(self, value: AccelFullRange) -> None:
        self._config.afr = value
