from typing import Union

from rx.core.typing import Observable

from sfm2.interface.sample_types import VectorSample
from sfm2.interface.sfm2_config import SampleRate, Sfm2Config, GyroFullRange
from sfm2.interface.sfm2_data import Sfm2Data
from sfm2.interface.sfm2_gyroscope import Sfm2Gyroscope


class Sfm2GyroscopeImpl(Sfm2Gyroscope):
    def __init__(self, config: Sfm2Config, data: Sfm2Data):
        self._config = config
        self._data = data

    @property
    def data(self) -> Observable[VectorSample]:
        return self._data.gd

    @property
    def rate(self) -> SampleRate:
        return self._config.gsr

    @rate.setter
    def rate(self, rate: Union[SampleRate, float]) -> None:
        self._config.gsr = rate

    @property
    def range(self) -> GyroFullRange:
        return self._config.gfr

    @range.setter
    def range(self, value: GyroFullRange) -> None:
        self._config.gfr = value
