from datetime import timedelta
from typing import Union

_RTC_TICK_FREQUENCY = 32768
_RTC_TICK_INTERVAL_S = 1 / _RTC_TICK_FREQUENCY


def sfm2_rtc_to_seconds(rtc_ticks: Union[int, float]) -> float:
    return rtc_ticks * _RTC_TICK_INTERVAL_S


def sfm2_rtc_to_timedelta(rtc_ticks: Union[int, float]) -> timedelta:
    return timedelta(seconds=sfm2_rtc_to_seconds(rtc_ticks))


def sfm2_rtc_from_timedelta(ts: timedelta) -> int:
    s = ts.total_seconds()
    return sfm2_rtc_from_seconds(s)


def sfm2_rtc_from_seconds(seconds: float) -> int:
    ticks = seconds * _RTC_TICK_FREQUENCY
    return int(round(ticks))
