from dataclasses import dataclass
from enum import Enum
from typing import Dict

from sfm2.interface.sample_types import Sample


class SampleTag(Enum):
    AD = "AD"
    GD = "GD"
    MD = "MD"
    SFQ = "SFQ"
    SFQT = "SFQT"
    SFLA = "SFLA"
    SFEA = "SFEA"
    SFCHT = "SFCHT"
    SFM = "SFM"
    PD = "PD"
    ALTD = "ALTD"
    TD = "TD"
    HD = "HD"
    TS = "TS"


@dataclass
class BinaryModeFrame:
    samples: Dict[SampleTag, Sample]

    def __str__(self):
        sample_names = [v.type.name for v in self.samples.values()]
        joined_names = ", ".join(sample_names)
        return f"[{joined_names}]"
