import functools
from enum import Enum


@functools.total_ordering
class SampleRate(Enum):
    OFF = 0
    HZ_0 = 0
    HZ_12_5 = 13
    HZ_26 = 26
    HZ_52 = 52
    HZ_104 = 104
    HZ_208 = 208
    HZ_417 = 417
    HZ_833 = 833
    HZ_1667 = 1667
    MAX = 1667

    def __lt__(self, other):
        if self.__class__ is other.__class__:
            return self.value < other.value
        return NotImplemented


class AccelFullRange(Enum):
    G_2 = 2
    G_4 = 4
    G_8 = 8
    G_16 = 16


class GyroFullRange(Enum):
    DPS_125 = 125
    DPS_250 = 250
    DPS_500 = 500
    DPS_1000 = 1000
    DPS_2000 = 2000
