from abc import ABC, abstractmethod

from sfm2.interface.sfm2 import Sfm2


class FoundSfm2(ABC):
    """
    Represents a found SFM2 device that can be connected to.

    """

    @property
    @abstractmethod
    def label(self) -> str:
        """
        Returns the label of the found device.

        The label may be any string that identifies the device, such as serial port name.

        :rtype: str
        """
        pass

    @abstractmethod
    def connect(self) -> Sfm2:
        """
        Connects to the device.

        :rtype: Sfm2
        """
        pass
