from abc import ABC, abstractmethod

from rx.core.typing import Observable

from sfm2.interface.sample_types import VectorSample, QuaternionSample, HeadingTiltSample, FloatSample, TimeSyncSample


class Sfm2Data(ABC):
    """
    Allows to access all the available data streams.
    """

    @property
    @abstractmethod
    def ad(self) -> Observable[VectorSample]:
        pass

    @property
    @abstractmethod
    def gd(self) -> Observable[VectorSample]:
        pass

    @property
    @abstractmethod
    def md(self) -> Observable[VectorSample]:
        pass

    @property
    @abstractmethod
    def sfq(self) -> Observable[QuaternionSample]:
        pass

    @property
    @abstractmethod
    def sfqt(self) -> Observable[QuaternionSample]:
        pass

    @property
    @abstractmethod
    def sfla(self) -> Observable[VectorSample]:
        pass

    @property
    @abstractmethod
    def sfea(self) -> Observable[VectorSample]:
        pass

    @property
    @abstractmethod
    def sfcht(self) -> Observable[HeadingTiltSample]:
        pass

    @property
    @abstractmethod
    def sfm(self) -> Observable[VectorSample]:
        pass

    @property
    @abstractmethod
    def pd(self) -> Observable[FloatSample]:
        pass

    @property
    @abstractmethod
    def altd(self) -> Observable[FloatSample]:
        pass

    @property
    @abstractmethod
    def td(self) -> Observable[FloatSample]:
        pass

    @property
    @abstractmethod
    def hd(self) -> Observable[FloatSample]:
        pass

    @property
    @abstractmethod
    def ts(self) -> Observable[TimeSyncSample]:
        pass
