from dataclasses import dataclass


@dataclass(frozen=True)
class Sfm2InitOptions:
    """
    Aggregates extra options that can be passed when creating :class:`~sfm2.interface.sfm2.Sfm2` instances.
    All fields have default values so you only need to specify those you want to change.
    """
    skip_version_check: bool = False
    cache_name: bool = True
    terminate_serial_on_error: bool = False
    response_timeout_s: float = 2
    log_all_cmds: bool = False
    verify_all_cmd_response_values: bool = True
    reset_retries_after_timeout: int = 3
    delay_after_reset_s: float = 0.5
    serial_port_sync_enabled: bool = True
    serial_port_sync_timeout_s: float = 10
    serial_rx_timeout_s: float = 1
    self_test_timeout_s: float = 20
    enable_acc_for_env_sensors: bool = True


@dataclass(frozen=True)
class Sfm2CollectionInitOptions:
    """
    Aggregates extra options that apply to :class:`~sfm2.utils.sfm2_collection.Sfm2Collection`
    """
    ignore_connection_errors: bool = False
    key_by_id_not_name: bool = False
    allow_duplicate_keys: bool = False
